/*******************************************************************
FileName:		TeleShellTrayRefresh.cpp

Description:	 Ʈ  Ѵ!

CREATED:		2006-09-12
LAST MODIFIED	2006-09-12

BY: 			KwangHee Yoo 
				cpueblo@cpueblo.com, yurchi@hanmail.net
				http://www.cpueblo.com
***********************************************************************/

//=========================================================
// INCLUDE  . MFC  , Ǵ ڽ Preheader ش Ϸ ü
//=========================================================
#include "StdAfx.h"
#include "TeleShellTrayRefresh.h"


//=========================================================
// ü 
//=========================================================
struct TRAYDATA
{
	HWND hwnd;
	UINT uID;
	UINT uCallbackMessage;
	DWORD Reserved[2];
	HICON hIcon;
};

//=========================================================
// Tray  μ ̸    ڵ  Լ
//=========================================================
static HWND FindTrayToolbarWindow()
{
    HWND hWnd_ToolbarWindow32 = NULL;
	HWND hWnd_ShellTrayWnd;

    hWnd_ShellTrayWnd = ::FindWindow(_T("Shell_TrayWnd"), NULL);
	if(hWnd_ShellTrayWnd)
	{
		HWND hWnd_TrayNotifyWnd = ::FindWindowEx(hWnd_ShellTrayWnd,NULL,_T("TrayNotifyWnd"), NULL);

		if(hWnd_TrayNotifyWnd)
		{
			HWND hWnd_SysPager = ::FindWindowEx(hWnd_TrayNotifyWnd,NULL,_T("SysPager"), NULL);	// WinXP

			// WinXP  SysPager              
			if(hWnd_SysPager)
			{
				hWnd_ToolbarWindow32 = ::FindWindowEx(hWnd_SysPager, NULL,_T("ToolbarWindow32"), NULL);
			}

            // Win2000  쿡 SysPager   TrayNotifyWnd -> ToolbarWindow32  Ѿ
        	else
            {
            	hWnd_ToolbarWindow32 = ::FindWindowEx(hWnd_TrayNotifyWnd, NULL,_T("ToolbarWindow32"), NULL);
            }
		}
	}
    
	return hWnd_ToolbarWindow32;
}


//=========================================================
// 
//=========================================================
TeleShellTrayRefresh::TeleShellTrayRefresh()
{

}


//=========================================================
// Ҹ
//=========================================================
TeleShellTrayRefresh::~TeleShellTrayRefresh()
{

}


//=========================================================
// Refresh  
//=========================================================
bool TeleShellTrayRefresh::Refresh()
{
	try
	{
		HANDLE 			m_hProcess;
		LPVOID 			m_lpData;
		TBBUTTON		tb;
		TRAYDATA		tray;
		DWORD 			dwTrayPid;
        int				TrayCount;
		
		// Tray   ڵ 
		HWND m_hTrayWnd = FindTrayToolbarWindow();
        if (m_hTrayWnd == NULL)
			return false;
		
		// Tray   ϰ
		TrayCount = (int)::SendMessage(m_hTrayWnd, TB_BUTTONCOUNT, 0, 0);
		
		// Tray  ڵ PID  Ѵ
		GetWindowThreadProcessId(m_hTrayWnd, &dwTrayPid);
		
        // ش Tray  Process   ޸𸮸 ҴѴ
		m_hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwTrayPid);
        if (!m_hProcess)
			return false;
		
        // ش μ  ޸𸮸 Ҵ
		m_lpData = VirtualAllocEx(m_hProcess, NULL, sizeof (TBBUTTON), MEM_COMMIT, PAGE_READWRITE);
		if (!m_lpData)
			return false;
		
		// Tray ŭ 
		for(int i = 0; i < TrayCount; i++)
		{
			::SendMessage(m_hTrayWnd, TB_GETBUTTON, i, (LPARAM)m_lpData);	
			
			// TBBUTTON  ü TRAYDATA   
			ReadProcessMemory(m_hProcess, m_lpData, (LPVOID)&tb, sizeof (TBBUTTON), NULL);
            ReadProcessMemory(m_hProcess, (LPCVOID)tb.dwData, (LPVOID)&tray, sizeof (tray), NULL);
            
			//  Ʈ μ ȣ 
			DWORD dwProcessId = 0;
			GetWindowThreadProcessId(tray.hwnd, &dwProcessId);
			
			// Process    TrayIcon  Ѵ
			if (dwProcessId == 0)
			{
				NOTIFYICONDATA	icon;
				icon.cbSize	= sizeof(NOTIFYICONDATA);
				icon.hIcon	= tray.hIcon;
				icon.hWnd	= tray.hwnd;
				icon.uCallbackMessage = tray.uCallbackMessage;
				icon.uID	= tray.uID;
				
				Shell_NotifyIcon(NIM_DELETE, &icon);
			}
		}
		
        //  ޸  μ ڵ ݱ
		VirtualFreeEx(m_hProcess, m_lpData, NULL, MEM_RELEASE);
		CloseHandle(m_hProcess);        
		
		return true;
	}
	catch (...)
	{
		return false;
	}
}

